#include "list.h"

struct ListNode * makeListNode(datum_t num)
{
    struct ListNode *result = malloc(sizeof(struct ListNode));
    result->next = NULL;
    result->datum = num;
    return result;
}

void insertAfter(struct ListNode *first, struct ListNode *next) 
{ 
    if (first!=NULL) 
        first->next = next; 
}

struct List * makeList()
{
    struct List *result = malloc(sizeof(struct List));
    result->head = NULL;
    result->tail = result->head;
    result->length = 0;
    return result;
}

void appendToList(struct List *l, datum_t num)
{
    if (l->length >= MAXLISTLENGTH)
        return;
    if (l->tail == NULL) { // empty list!
        l->head = makeListNode(num);
        l->tail = l->head;
    } else {
        insertAfter(l->tail, makeListNode(num));
        l->tail = l->tail->next;
    }
    l->length++;
}

void killList(struct List **l)
{
    struct List *listp = *l;
    if (listp == NULL)
        return;
    struct ListNode * pointer = listp->head,
                    * temp;
    while ((temp = pointer)) {
        pointer = pointer->next;
        free(temp);
    }
    free(listp);
    *l = NULL;
}


struct ListEnum * makeEnum(struct List *list)
{
    struct ListEnum *result = malloc(sizeof(struct ListEnum));
    result->pointer = list->head;
    result->value = (datum_t) NULL;
    result->index = -1;
    result->hasNext = (list->head != NULL);
}
datum_t nextDatum(struct ListEnum *lEnum)
{
    if (!lEnum->hasNext) {
        return (datum_t) NULL;
    }
    lEnum->value = lEnum->pointer->datum;
    lEnum->index++;
    lEnum->pointer = lEnum->pointer->next;
    lEnum->hasNext = (lEnum->pointer != NULL);
    
    return lEnum->value;
}
