#include <stdlib.h>
#include "buttons.h"

//#ifdef USB_DEBUGGING
# include "print.h"
//#endif

#include <avr/interrupt.h>
#include <util/delay.h>

ISR(INT0_vect) // code button
{   
#ifdef USB_DEBUGGING
    print("\n###Code: ");
#endif
    if ((EICRA & 0x3) == 0x0) { // doing H-L transitions?
#ifdef USB_DEBUGGING
	    print("DOWN###\n");
#endif
        EICRA |= 0x3; // was detecting H-L transitions; now, do L-H instead
        if (fp_codeSWDown != NULL) {
            fp_codeSWDown();
        }
    } else {
#ifdef USB_DEBUGGING
	    print("UP###\n");
#endif
	    EICRA &= ~0x3; // was detecting L-H transistions; now, do H-L
	    if (fp_codeSWUp != NULL)
	        fp_codeSWUp();
    }
}

ISR(INT1_vect) // start button
{
#ifdef USB_DEBUGGING
    print("\n###Start: ");
#endif
    if ((EICRA & 0xc) == 0x0) { // doing H-L transitions?
#ifdef USB_DEBUGGING
	    print("DOWN###\n");
#endif
        EICRA |= 0xc;   // was doing H-L; now do L-H
        if (fp_startSWDown != NULL) {
            fp_startSWDown();
        }
    } else {
#ifdef USB_DEBUGGING
	    print("UP###\n");
#endif
	    EICRA &= ~0xc; // was doing L-H; now do H-L
	    if (fp_startSWUp != NULL)
	        fp_startSWUp();
    }
}

void initButtonInterrupts(void)
{
    EICRA = 0x0; // detect when low (H-L transition)
    EIMSK = 0x3; // enable INT0 and INT1
}

